#include <gtk/gtk.h>

static gboolean
on_window_draw(GtkWidget *widget, cairo_t *cr, GdkPixbuf *pb)
{
  cairo_rectangle(cr, 0.0, 0.0, gdk_pixbuf_get_width(pb), gdk_pixbuf_get_height(pb));
  gdk_cairo_set_source_pixbuf(cr, pb, 0.0, 0.0);
  cairo_paint(cr);
  return TRUE;
}

int main(int argc, char *argv[])
{
  GtkWidget *win;
  GdkPixbuf *pb = NULL;

  gtk_init(&argc, &argv);

  win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  g_signal_connect(win, "destroy", gtk_main_quit, NULL);

  if (argc > 1) {
    GError *error = NULL;
    pb = gdk_pixbuf_new_from_file(argv[1], &error);
    if (!pb) {
      g_critical("Failed to load pixbuf: %s: %s", argv[1], error->message);
      g_error_free(error); error=NULL;
    } else {
      g_signal_connect(win, "draw", G_CALLBACK(on_window_draw), pb);
    }
  } else {
    g_critical("Not enough arguments, expecting filename");
  }

  gtk_widget_show(win);

  gtk_main();

  if (pb)
    g_object_unref(pb);

  return 0;
}